IOSS 2.0

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
Ioex::SuperElement Class Reference

`#include <Ioex_SuperElement.h>`

Inheritance diagram for Ioex::SuperElement:
[legend]
Collaboration diagram for Ioex::SuperElement:
[legend]

## Public Member Functions
| SuperElement (std::string filename, const std::string &my_name)
| ~SuperElement () override
std::string | type_string () const override
| Get the name of the particular type of entity. More...
std::string | short_type_string () const override
| Get a short name of the particular type of entity. More...
std::string | contains_string () const override
| What does this entity contain. More...
Ioss::EntityType | type () const override
| Get the EntityType, which indicates the particular type of GroupingEntity this is. More...
Ioss::Property | get_implicit_property (const std::string &the_name) const override
| Calculate and get an implicit property. More...
Public Member Functions inherited from Ioss::GroupingEntity
| GroupingEntity ()=default
| GroupingEntity (DatabaseIO *io_database, const std::string &my_name, int64_t entity_count)
| Base class constructor adds "name" and "entity_count" properties to the entity. More...
| GroupingEntity (const GroupingEntity &)=delete
GroupingEntity & | operator= (const GroupingEntity &)=delete
virtual | ~GroupingEntity ()
State | get_state () const
| Get the current Ioss::State of the entity. More...
DatabaseIO * | get_database () const
void | set_database (DatabaseIO *io_database)
virtual void | delete_database ()
virtual const GroupingEntity * | contained_in () const
const std::string & | name () const
| Get name of entity. More...
void | set_name (const std::string &new_name)
| Set the name of the entity. More...
std::string | generic_name () const
| Get a generated name based on the type of the entity and the id. More...
bool | is_alias (const std::string &my_name) const
virtual void | block_membership (std::vector< std::string > &)
| Get list of blocks that the entities in this GroupingEntity "touch". More...
std::string | get_filename () const
| Get the file name associated with the database containing this entity. More...
void | property_add (const Property &new_prop)
| Add a property to the entity's property manager. More...
void | property_erase (const std::string &property_name)
| Remove a property from the entity's property manager. More...
bool | property_exists (const std::string &property_name) const
| Checks if a property exists in the entity's property manager. More...
Property | get_property (const std::string &property_name) const
| Get the Property from the property manager associated with the entity. More...
int | property_describe (NameList *names) const
| Get the names of all properties in the property manager for this entity. More...
size_t | property_count () const
| Get the number of properties defined in the property manager for this entity. More...
void | property_update (const std::string &property, int64_t value) const
void | property_update (const std::string &property, const std::string &value) const
void | field_add (const Field &new_field)
| Add a field to the entity's field manager. More...
void | field_erase (const std::string &field_name)
| Remove a field from the entity's field manager. More...
bool | field_exists (const std::string &field_name) const
| Checks if a field with a given name exists in the entity's field manager. More...
Field | get_field (const std::string &field_name) const
| Get a field from the entity's field manager. More...
const Field & | get_fieldref (const std::string &field_name) const
| Get a reference to a field from the entity's field manager. More...
int | field_describe (NameList *names) const
| Get the names of all fields in the entity's field manager. More...
int | field_describe (Field::RoleType role, NameList *names) const
| Get the names of all fields of a specified RoleType in the entity's field manager. More...
size_t | field_count () const
| Get the number of fields in the entity's field manager. More...
size_t | field_count (Field::RoleType role) const
| Get the number of fields with the given role (MESH, ATTRIBUTE, TRANSIENT, REDUCTION, etc.) in the entity's field manager. More...
int64_t | get_field_data (const std::string &field_name, void *data, size_t data_size) const
| Read field data from the database file into memory using a pointer. More...
int64_t | put_field_data (const std::string &field_name, void *data, size_t data_size) const
| Write field data from memory into the database file using a pointer. More...
template<typename T >
int64_t | get_field_data (const std::string &field_name, std::vector< T > &data) const
| Read type 'T' field data from the database file into memory using a std::vector. More...
template<typename T >
int64_t | put_field_data (const std::string &field_name, const std::vector< T > &data) const
| Write type 'T' field data from memory into the database file using a std::vector. More...
template<typename T >
int64_t | put_field_data (const std::string &field_name, std::vector< T > &data) const
Ioss::Field::BasicType | field_int_type () const
unsigned int | hash () const
int64_t | entity_count () const

## Protected Member Functions
int64_t | internal_get_field_data (const Ioss::Field &field, void *data, size_t data_size) const override
int64_t | internal_put_field_data (const Ioss::Field &field, void *data, size_t data_size) const override
Protected Member Functions inherited from Ioss::GroupingEntity
void | count_attributes () const
bool | set_state (State new_state)
void | really_delete_database ()

## Private Attributes
std::string | fileName {}
size_t | numDOF {0}
size_t | num_nodes {0}
size_t | numEIG {0}
size_t | numRBM {0}
size_t | num_dim {0}
int | filePtr {-1}

## Additional Inherited Members
Protected Attributes inherited from Ioss::GroupingEntity
PropertyManager | properties
FieldManager | fields
int64_t | entityCount = 0

## Constructor & Destructor Documentation

## ◆ SuperElement()

Ioex::SuperElement::SuperElement | ( | std::string | filename,
|  | const std::string & | my_name
| ) |  |

## ◆ ~SuperElement()

Ioex::SuperElement::~SuperElement | ( |  | ) |
| override

## Member Function Documentation

## ◆ contains_string()

std::string Ioex::SuperElement::contains_string | ( |  | ) | const
| inline override virtual

What does this entity contain.

Returns
  The name of the thing this entity contains.

Implements Ioss::GroupingEntity.

## ◆ get_implicit_property()

Ioss::Property Ioex::SuperElement::get_implicit_property | ( | const std::string & | my_name | ) | const
| override virtual

Calculate and get an implicit property.

These are calcuated from data stored in the EntityBlock instead of having an explicit value assigned. An example would be 'element_block_count' for a region. Note that even though this is a pure virtual function, an implementation is provided to return properties that are common to all 'block'-type grouping entities. Derived classes should call 'GroupingEntity::get_implicit_property' if the requested property is not specific to their type.

Implements Ioss::GroupingEntity.

## ◆ internal_get_field_data()

int64_t Ioex::SuperElement::internal_get_field_data | ( | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| override protected virtual

Implements Ioss::GroupingEntity.

## ◆ internal_put_field_data()

int64_t Ioex::SuperElement::internal_put_field_data | ( | const Ioss::Field & | field,
|  | void * | data,
|  | size_t | data_size
| ) |  | const
| override protected virtual

Implements Ioss::GroupingEntity.

## ◆ short_type_string()

std::string Ioex::SuperElement::short_type_string | ( |  | ) | const
| inline override virtual

Get a short name of the particular type of entity.

Returns
  The short name of the particular type of entity.

Implements Ioss::GroupingEntity.

## ◆ type()

Ioss::EntityType Ioex::SuperElement::type | ( |  | ) | const
| inline override virtual

Get the EntityType, which indicates the particular type of GroupingEntity this is.

Returns
  The particular EntityType of this GroupingEntity.

Implements Ioss::GroupingEntity.

## ◆ type_string()

std::string Ioex::SuperElement::type_string | ( |  | ) | const
| inline override virtual

Get the name of the particular type of entity.

Returns
  The name of the particular type of entity.

Implements Ioss::GroupingEntity.

## Member Data Documentation

## ◆ fileName

std::string Ioex::SuperElement::fileName {}
| private

## ◆ filePtr

int Ioex::SuperElement::filePtr {-1}
| private

## ◆ num_dim

size_t Ioex::SuperElement::num_dim {0}
| private

## ◆ num_nodes

size_t Ioex::SuperElement::num_nodes {0}
| private

## ◆ numDOF

size_t Ioex::SuperElement::numDOF {0}
| private

## ◆ numEIG

size_t Ioex::SuperElement::numEIG {0}
| private

## ◆ numRBM

size_t Ioex::SuperElement::numRBM {0}
| private

The documentation for this class was generated from the following files:

- src/exodus/Ioex_SuperElement.h
- src/exodus/Ioex_SuperElement.C